let data = []; // data from json file

/***** DOM element's reference ************/
let cardsElement;
let navElement;
let flashCardElement;
let buttons;
let body;
let gradientBackgroundElement;

/****** FLASH CARDS variables **************/
let isAnswerVisible;
let selectedCategoryIndex;
let counter;
let correctAnswers;
let wrongAnswers;


// after the document is loaded
$(document).ready(function () {
    // init reference to DOM elements
    cardsElement = $(".cards");
    navElement = $("nav");
    flashCardElement = $(".flash-card-wrapper");
    buttons = $(".buttons");
    body = $("body");
    gradientBackgroundElement = $(".gradient-background");

    // load json data
    data = window.dataJson.data;
    goToMainPage();
});

/**
 * Function displays cards on the main screen
 */
function displayCards() {
    let htmlCode = "";
    // @TODO foreach all data and for each category, create a card with image and title
    for (let i = 0; i < data.length; i++) {
        const {category, title, photo_url, cards} = data[i]
        // @TODO
        // htmlCode = htmlCode + ``
    }
    cardsElement.html(htmlCode); // add HTML content to the page
}

/**
 * Function initializes the main page and clear all unnecessary elements
 */
function goToMainPage() {
    // no buttons, cards, gradien on main page
    buttons.html("")
    flashCardElement.html("")
    gradientBackgroundElement.hide();
    flashCardElement.hide();
    body.removeClass("practise") // remove background color

    // @TODO 
    // navElement.html(``)
    displayCards()
}



/**
 * Function displays screen with flash card, wrong and correct buttons, chip with an order of questions
 * @param index index of selected category
 */
function learnByCategory(index) {
    initVariables() // init all globals
    selectedCategoryIndex = index; // set index of learning category
    const {category, title, cards} = data[index]; // destruct data
    if (cards.length <= counter) {
        // prevent out of array
        goToMainPage();
        return;
    }
    cardsElement.html(""); // delete cards on the main screen as we don't need them
    // @TODO
    // navElement.html();
    flashCardElement.show();
    gradientBackgroundElement.show();
    drawFlashCard();
    // @TODO 
    // buttons.html();
    body.addClass("practise"); // set background color
}

/**
 * Function displays flash card in playing mode
 * it takes into account isAnswerVisible var
 */
function drawFlashCard() {
    const {cards} = data[selectedCategoryIndex];
    const {question, answer} = cards[counter];
    const questionText = isAnswerVisible ? answer : question;
    const buttonText = isAnswerVisible ? "Hide answer" : "Show answer";
    // @TODO 
    // flashCardElement.html();
}

/**
 * Toggle card answer visibility
 */
function toggleAnswerVisibility() {
    isAnswerVisible = !isAnswerVisible;
    drawFlashCard();
}

/**
 * Increment counter and either goes to summary or displays next flash card
 */
function nextCard() {
    isAnswerVisible = false;
    const {cards} = data[selectedCategoryIndex];
    if (counter >= cards.length - 1) {
        goToSummary(); // there is no next card, let's how summary
    } else {
        counter = counter + 1; // lets go to next question
        drawFlashCard();
    }
}

/**
 * Save correct answer and call nextCard
 */
function onCorrect() {
    correctAnswers.push(counter);
    nextCard();
}

/**
 * Save wrong answer and call nextCard
 */
function onWrong() {
    wrongAnswers.push(counter);
    nextCard();
}

/**
 * Creates summary content with num of wrong and correct answers
 */
function goToSummary() {
    // @TODO
    // flashCardElement.html(``);
    // buttons.html(``);
}
